| OpenCV 3.4.7 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::bioinspired::TransientAreasSegmentationModule Class Referenceabstract
Biologically inspired vision models and derivated tools

class which provides a transient/moving areas segmentation module More...

`#include <opencv2/bioinspired/transientareassegmentationmodule.hpp>`

Inheritance diagram for cv::bioinspired::TransientAreasSegmentationModule:

## Public Member Functions
virtual void | clearAllBuffers ()=0
| cleans all the buffers of the instance More...
virtual SegmentationParameters | getParameters ()=0
| return the current parameters setup More...
virtual void | getSegmentationPicture (OutputArray transientAreas)=0
| access function return the last segmentation result: a boolean picture which is resampled between 0 and 255 for a display purpose More...
virtual Size | getSize ()=0
| return the sze of the manage input and output images More...
virtual const String | printSetup ()=0
| parameters setup display method More...
virtual void | run (InputArray inputToSegment, const int channelIndex=0)=0
| main processing method, get result using methods getSegmentationPicture() More...
virtual void | setup (String segmentationParameterFile="", const bool applyDefaultSetupOnFailure=true)=0
| try to open an XML segmentation parameters file to adjust current segmentation instance setup More...
virtual void | setup (cv::FileStorage &fs, const bool applyDefaultSetupOnFailure=true)=0
| try to open an XML segmentation parameters file to adjust current segmentation instance setup More...
virtual void | setup (SegmentationParameters newParameters)=0
| try to open an XML segmentation parameters file to adjust current segmentation instance setup More...
virtual void | write (String fs) const =0
| write xml/yml formated parameters information More...
virtual void | write (cv::FileStorage &fs) const CV_OVERRIDE=0
| write xml/yml formated parameters information More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< TransientAreasSegmentationModule > | create (Size inputSize)
| allocator More...
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

class which provides a transient/moving areas segmentation module

perform a locally adapted segmentation by using the retina magno input data Based on Alexandre BENOIT thesis: "Le système visuel humain au secours de la vision par ordinateur"

3 spatio temporal filters are used:

- a first one which filters the noise and local variations of the input motion energy
- a second (more powerfull low pass spatial filter) which gives the neighborhood motion energy the segmentation consists in the comparison of these both outputs, if the local motion energy is higher to the neighborhood otion energy, then the area is considered as moving and is segmented
- a stronger third low pass filter helps decision by providing a smooth information about the "motion context" in a wider area

## Member Function Documentation

## § clearAllBuffers()

virtual void cv::bioinspired::TransientAreasSegmentationModule::clearAllBuffers | ( |  | ) |
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.clearAllBuffers( |  | )

cleans all the buffers of the instance

## § create()

static Ptr<TransientAreasSegmentationModule> cv::bioinspired::TransientAreasSegmentationModule::create | ( | Size | inputSize | ) |
| static

Python:
| retval | = | cv.bioinspired.TransientAreasSegmentationModule_create( | inputSize | )

allocator

Parameters

  inputSize | : size of the images input to segment (output will be the same size)

## § getParameters()

virtual SegmentationParameters cv::bioinspired::TransientAreasSegmentationModule::getParameters | ( |  | ) |
| pure virtual

return the current parameters setup

## § getSegmentationPicture()

virtual void cv::bioinspired::TransientAreasSegmentationModule::getSegmentationPicture | ( | OutputArray | transientAreas | ) |
| pure virtual

Python:
| transientAreas | = | cv.bioinspired_TransientAreasSegmentationModule.getSegmentationPicture( | [, transientAreas] | )

access function return the last segmentation result: a boolean picture which is resampled between 0 and 255 for a display purpose

## § getSize()

virtual Size cv::bioinspired::TransientAreasSegmentationModule::getSize | ( |  | ) |
| pure virtual

Python:
| retval | = | cv.bioinspired_TransientAreasSegmentationModule.getSize( |  | )

return the sze of the manage input and output images

## § printSetup()

virtual const String cv::bioinspired::TransientAreasSegmentationModule::printSetup | ( |  | ) |
| pure virtual

Python:
| retval | = | cv.bioinspired_TransientAreasSegmentationModule.printSetup( |  | )

parameters setup display method

Returns
  a string which contains formatted parameters information

## § run()

virtual void cv::bioinspired::TransientAreasSegmentationModule::run | ( | InputArray | inputToSegment,
|  | const int | channelIndex = `0`
| ) |  |
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.run( | inputToSegment[, channelIndex] | )

main processing method, get result using methods getSegmentationPicture()

Parameters

  inputToSegment | : the image to process, it must match the instance buffer size !
  channelIndex | : the channel to process in case of multichannel images

## § setup() [1/3]

virtual void cv::bioinspired::TransientAreasSegmentationModule::setup | ( | String | segmentationParameterFile = `""`,
|  | const bool | applyDefaultSetupOnFailure = `true`
| ) |  |
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.setup( | [, segmentationParameterFile[, applyDefaultSetupOnFailure]] | )

try to open an XML segmentation parameters file to adjust current segmentation instance setup

- if the xml file does not exist, then default setup is applied
- warning, Exceptions are thrown if read XML file is not valid
  Parameters

    segmentationParameterFile | : the parameters filename
    applyDefaultSetupOnFailure | : set to true if an error must be thrown on error

## § setup() [2/3]

virtual void cv::bioinspired::TransientAreasSegmentationModule::setup | ( | cv::FileStorage & | fs,
|  | const bool | applyDefaultSetupOnFailure = `true`
| ) |  |
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.setup( | [, segmentationParameterFile[, applyDefaultSetupOnFailure]] | )

try to open an XML segmentation parameters file to adjust current segmentation instance setup

- if the xml file does not exist, then default setup is applied
- warning, Exceptions are thrown if read XML file is not valid
  Parameters

    fs | : the open Filestorage which contains segmentation parameters
    applyDefaultSetupOnFailure | : set to true if an error must be thrown on error

## § setup() [3/3]

virtual void cv::bioinspired::TransientAreasSegmentationModule::setup | ( | SegmentationParameters | newParameters | ) |
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.setup( | [, segmentationParameterFile[, applyDefaultSetupOnFailure]] | )

try to open an XML segmentation parameters file to adjust current segmentation instance setup

- if the xml file does not exist, then default setup is applied
- warning, Exceptions are thrown if read XML file is not valid
  Parameters

    newParameters | : a parameters structures updated with the new target configuration

## § write() [1/2]

virtual void cv::bioinspired::TransientAreasSegmentationModule::write | ( | String | fs | ) | const
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.write( | fs | )

write xml/yml formated parameters information

Parameters

  fs | : the filename of the xml file that will be open and writen with formatted parameters information

## § write() [2/2]

virtual void cv::bioinspired::TransientAreasSegmentationModule::write | ( | cv::FileStorage & | fs | ) | const
| pure virtual

Python:
| None | = | cv.bioinspired_TransientAreasSegmentationModule.write( | fs | )

write xml/yml formated parameters information

Parameters

  fs | : a cv::Filestorage object ready to be filled

Reimplemented from cv::Algorithm.

The documentation for this class was generated from the following file:

- opencv2/bioinspired/transientareassegmentationmodule.hpp